/* -*- c++ -*-
FILE: Math4d.h
RCS REVISION: $Revision: 1.11 $

COPYRIGHT: (c) 1999 -- 2003 Melinda Green, Don Hatch, and Jay Berkenbilt - Superliminal Software

LICENSE: Free to use and modify for non-commercial purposes as long as the
    following conditions are adhered to:
    1) Obvious credit for the source of this code and the designs it embodies
       are clearly made, and
    2) Ports and derived versions of 4D Magic Cube programs are not distributed
       without the express written permission of the authors.

DESCRIPTION:
    This class includes a collection of static functions used to
    perform the 4D math involved in manipulating the puzzle.
*/

#ifndef MATH4D_H
#define MATH4D_H

#include "MagicCube.h"

class Math4d
{
public:
    static void get4dRotMatrix(real center[4], real axispoint[4], real angle,
                               real mat[4][4]);


    static void get4dTwistMat(int coords[4], real total_angle,
                              int imat[4][4]);

    static void getCanonicalMatThatTakesAxisToMinusW(
        int ax, int sgn, int mat[4][4]);


    // Return 1 on success, 0 on failure.
    static int get4dMatThatRotatesThese3ToThose3(
        int these0[4], int these1[4], int these2[4],
        int those0[4], int those1[4], int those2[4],
        int mat[4][4]); /* OUTPUT */

private:
    static void get3dRotMatrixAboutAxis(real axis[3], real angle,
                                        real mat[3][3]);
};

#endif

// Local Variables:
// c-basic-offset: 4
// c-comment-only-line-offset: 0
// c-file-offsets: ((defun-block-intro . +) (block-open . 0) (substatement-open . 0) (statement-cont . +) (statement-case-open . +4) (arglist-intro . +) (arglist-close . +) (inline-open . 0))
// indent-tabs-mode: nil
// End:
